<?php

class Ajw_client_downloads_CP {

	var $version = '1.0.2';
	var $module_name = "Ajw_client_downloads";

	function Ajw_client_downloads_CP( $switch = TRUE )
	{
		global $IN, $DB, $DSP;

		// Upgrade module if necessary
		$query = $DB->query( "SELECT module_version FROM exp_modules WHERE module_name = '" . $this->module_name . "'" );
		if( $query->num_rows > 0 ) {
			if( $query->row['module_version'] != $this->version )
			{
				$DB->query("UPDATE exp_modules SET module_version='".$this->version."' WHERE module_name='" . $this->module_name . "'");
			}
			if ( $query->row['module_version'] < "1.0.1" ) {
				// Add new fields to asset table
				$DB->query("ALTER TABLE `exp_ajw_client_downloads_asset` ADD `keywords` VARCHAR( 255 ) NOT NULL AFTER `title`, ADD `description` TEXT NOT NULL AFTER `keywords`;");
			}
			if ( $query->row['module_version'] < "1.0.2" ) {
				// Add new fields to asset table
				$DB->query("ALTER TABLE `exp_ajw_client_downloads_settings` ADD `user_fields` VARCHAR( 255 ) NOT NULL AFTER `email_body`, ADD `temp_path` VARCHAR( 255 ) NOT NULL AFTER `user_fields`;");
				$DB->query("ALTER TABLE `exp_ajw_client_downloads_settings` ADD `new_asset_email_from` VARCHAR( 255 ) NOT NULL AFTER `email_body`, ADD `new_asset_email_subject` VARCHAR( 255 ) NOT NULL AFTER `new_asset_email_from`,  ADD `new_asset_email_body` TEXT NOT NULL AFTER `new_asset_email_from`;");
			}
		}

		if ( $switch ) {
			switch($IN->GBL('P'))
			{
				case "users" : 
				$this->users();
				break;
				case "add_user" : 
				$this->add_user();
				break;
				case "edit_user" : 
				$this->edit_user();
				break;
				case "update_user" : 
				$this->update_user();
				break;
				case "delete_user" : 
				$this->delete_user();
				break;
				case "folders" : 
				$this->folders();
				break;
				case "edit_folder" : 
				$this->edit_folder();
				break;
				case "update_folder" : 
				$this->update_folder();
				break;
				case "delete_folder" : 
				$this->delete_folder();
				break;
				case "assets" : 
				$this->assets();
				break;
				case "edit_asset" : 
				$this->edit_asset();
				break;
				case "update_asset" : 
				$this->update_asset();
				break;
				case "upload_asset" : 
				$this->upload_asset();
				break;
				case "delete_asset" : 
				$this->delete_asset();
				break;
				case "upload_file" : 
				$this->upload_file();
				break;
				case "reports" : 
				$this->reports();
				break;
				case "settings" : 
				$this->settings();
				break;
				case "update_settings" : 
				$this->update_settings();
				break;
				case "multi_edit" : 
				$this->multi_edit();
				break;
				default : 
				$this->home();
				break;
			}
		}

	}
	// END


	function home() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		// Page header


		$r = "";
		
		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Home");    

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";

		$r .= $this->_navigation();

		$r .= "<h1>Client Download Area module</h1>";

		$query = $DB->query("SELECT * FROM exp_ajw_client_downloads_settings");

		if ( $query->num_rows > 0 ) {

		$r .= '<h2>' . 
			$DSP->anchor(BASE.
				AMP.'C=modules'.
				AMP.'M=ajw_client_downloads' .
				AMP."P=add_user", 
				"Create a new download area for a member") .
				'</h2>';

		$r .= '<h2>' . 
			$DSP->anchor(BASE.
				AMP.'C=modules'.
				AMP.'M=ajw_client_downloads' .
				AMP."P=upload_asset", 
				"Upload a new asset") .
				'</h2>';

		} else {
			
			$r .= '<h2>' . 
				$DSP->anchor(BASE.
					AMP.'C=modules'.
					AMP.'M=ajw_client_downloads' .
					AMP."P=settings", 
					"Set up module") .
					'</h2>';
			
		}

		$DSP->body .= $r;
	}

	function users() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		// Page header

		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->crumb .= $DSP->crumb_item('Users');    

		$DSP->right_crumb( 'Create new download area', BASE.AMP.'C=modules'.AMP.'M='.$this->module_name.AMP.'P=add_user');

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";

		$r = "";

		$r .= $this->_navigation();

		if ( $IN->GBL("folder_id") ) {
			$query = $DB->query("SELECT title FROM exp_ajw_client_downloads_folder WHERE id = " . $IN->GBL("folder_id"));
			$r .= "<h1>Users assigned to the folder " . $query->row["title"]. "</h1>";						
		} else {
			$r .= "<h1>Users</h1>";			
		}

		$query = $DB->query("SELECT user_fields FROM exp_ajw_client_downloads_settings");
		$fields = $query->row["user_fields"];

		$fieldStr = $fields;
		if ( $fields != "" ) { $fieldStr = $fields . ", "; }

		$sql = "SELECT  m.member_id, m.screen_name, m.username, m.email, " . $fieldStr . " count(*) as num_folders FROM exp_ajw_client_downloads_users u, exp_members m, exp_member_data d WHERE m.member_id = d.member_id AND u.member_id = m.member_id";
		if ( $IN->GBL("folder_id") ) {
			$sql .= " AND u.folder_id = " . $IN->GBL("folder_id");
		}
		$sql .= " GROUP BY 1";
		
		if ( $IN->GBL("orderby") != "" ) {
			$sql .= " ORDER BY " . $IN->GBL("orderby");			
		} else {
			$sql .= " ORDER BY screen_name";
		}
		if ( $IN->GBL("sort") != "" ) {
			$sql .= " " . $IN->GBL("sort");			
		} else {
			$sql .= " ASC";
		}
		
		$query = $DB->query($sql);

		$r .= $DSP->qdiv( 'tableHeading', 'Users' ); 

		$r .= $DSP->div('box');
		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M=ajw_client_downloads'.AMP.'P=users'
			)
		);

		if ( $IN->GBL("member_id") != "") {
			$r .= $DSP->input_hidden("member_id", $IN->GBL("member_id"));
		}
	
		$r .= "Sort: " . 
			$DSP->input_select_header("orderby") .
			$DSP->input_select_option("screen_name", "Name") .
			$DSP->input_select_option("email", "Email") .
			$DSP->input_select_option("join_date", "Join Date") .
			$DSP->input_select_footer();

		$r .= $DSP->input_select_header("sort") .
			$DSP->input_select_option("asc", "Ascending") .
			$DSP->input_select_option("desc", "Descending") .
			$DSP->input_select_footer();
		
		$r .= $DSP->input_submit("Submit");
		
		$r .= $DSP->form_close();
		$r .= $DSP->div_c();

		$titles = array(
			"Screen Name"
		);
		if ( $fields != "" ) {
			foreach( split(", ", $fields) as $field ) {
				$titles[] = '';
			}
		}
		$titles[] = '';
		$titles[] = '';
		$titles[] = '';
		

		$r .= $DSP->table('tableBorder', '0', '0', '100%') .
			$DSP->tr().
			$DSP->table_qcell('tableHeadingAlt',  $titles ) .
			$DSP->tr_c();

		$i = 0;

		$base_url = BASE.AMP.'C=modules'.AMP.'M='.$this->module_name.AMP;

		$group_name = '';
		foreach($query->result as $row)
		{
			$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

			$r .= $DSP->tr();

			$r .= $DSP->table_qcell($style, 
				$DSP->anchor( $base_url.'P=edit_user'.AMP.'member_id='.$row["member_id"], 
				$row["screen_name"], 'class="user"')
				,'','top');
			if ( $fields != "" ) {
				foreach( split(", ", $fields) as $field ) {
					$r .= $DSP->table_qcell($style, $row[ substr($field, 2) ],'','top');
				}
			}
			$r .= $DSP->table_qcell($style, 
				$DSP->anchor( $base_url.'P=folders'.AMP.'member_id='.$row["member_id"], "View folders", 'class="folder"') . ( $IN->GBL("folder_id") == "" ? " (" . $row["num_folders"]. ")" : "" ) 
				,'','top');
			$r .= $DSP->table_qcell($style, 
				$DSP->anchor( $base_url.'P=reports'.AMP.'member_id='.$row["member_id"], "View downloads", 'class="report"')
				,'','top');
			$r .= $DSP->table_qcell($style, 
				$DSP->anchor( $base_url.'P=delete_user'.AMP.'member_id='.$row["member_id"], "Delete", 'class="delete"')
				,'','top');

			$r .= $DSP->tr_c();

		}
		$r .= $DSP->table_c();

		$DSP->body .= $r;
	}

	function add_user() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		// Page header

		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Create download area");    

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";

		$r = "";

		$r .= $this->_navigation("users");

		$r .= "<h1>Create new download area</h1>";

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=update_user', 
				'name' => 'create_user', 
				'id' => 'create_user'
			)
		);

		$r .= $DSP->qdiv( 'tableHeading', 'Create a new download area' ); 
		$r .= $DSP->table('tableBorder', '0', '0', '100%');

		$sql = "SELECT  m.member_id, m.screen_name FROM exp_members m LEFT OUTER JOIN exp_ajw_client_downloads_users u ON m.member_id = u.member_id WHERE u.id IS NULL ORDER BY screen_name";
		$query = $DB->query($sql);
		$folders = "";
		foreach( $query->result as $row ) {
				$folders .= $DSP->input_select_option( $row["member_id"], $row["screen_name"] );
		}

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 'Members', '30%') 
		);
		if ( $folders != "" ) {
			$r .= $DSP->table_qcell(
				'tableCellOne', 
				$DSP->qdiv('defaultBold', 
					$DSP->qdiv('itemWrapper', 
						$DSP->input_select_header( 'member_id' ) . 
							$folders . 
							$DSP->input_select_footer() 
					)
				),
				'70%'
			);
		} else {
			$r .= $DSP->table_qcell(
				'tableCellOne', 
				$DSP->qdiv('itemWrapper', 
					"All members have a download area. " .
					$DSP->anchor(BASE.
						AMP.'C=modules'.
						AMP.'M=ajw_client_downloads'.AMP."P=users", "Click here" ) . " to edit"
				),
				'70%'
			);			
		}

		$r .= $DSP->tr_c();
		
		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 'Create a default folder for this user', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
				$DSP->input_radio('create_default', 'Yes') . 'Yes' .
				$DSP->input_radio('create_default', 'No', 1) . 'No'
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 'Title of default folder', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('folder_title', "", '35', '255', 'input', '45%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();
		
		$sql = "SELECT f.id, f.title FROM exp_ajw_client_downloads_folder f LEFT  OUTER  JOIN exp_ajw_client_downloads_folder_assets fa ON fa.folder_id = f.id GROUP BY 1";
		$query = $DB->query($sql);
		$folders = "";
		foreach( $query->result as $row ) {
			$folders .= $DSP->input_select_option($row["id"], $row["title"]);
		}

		$r .= $DSP->tr();
		$r .= $DSP->td('tableCellTwo', '', '', '', 'top') .
			$DSP->qdiv('defaultBold', 'Add to existing folders', '30%') .
			$DSP->td_c();
		$r .= $DSP->td('tableCellTwo', '', '', '', 'top') . 
					$DSP->input_select_header( 'folder[]', 'y', 8 ) . 
					$folders . 
					$DSP->input_select_footer() .
			$DSP->td_c();
			
		$r .= $DSP->tr_c();

		
		$r .= $DSP->table_c();

		$r .= $DSP->qdiv('itemWrapper', BR.$DSP->input_submit('Create new download area'));  

		$r .= $DSP->form_c();

		$DSP->body .= $r;
	}

	function edit_user($msg="") {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Edit user");    

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";

		$r = "";

		$r .= $this->_navigation("users");

		$query = $DB->query("SELECT screen_name FROM exp_members WHERE member_id = " . $IN->GBL("member_id"));

		$member_name =  $query->row["screen_name"];
		$r .= "<h1>Edit folders for " . $member_name . "</h1>";

		if ($msg != '')
		{
			$r .= $DSP->qdiv('successBox', $DSP->qdiv('success', $msg)) . BR;
		}

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=update_user', 
				'name' => 'edit_user', 
				'id' => 'edit_user'
			)
		);

		$r .= $DSP->input_hidden("member_id", $IN->GBL("member_id"));
		$r .= $DSP->input_hidden("update", "true");

		$r .= $DSP->qdiv( 'tableHeading', 'Edit a user' ); 
		$r .= $DSP->table('tableBorder', '0', '0', '100%');

		$sql = "SELECT f.id, f.title, count(u.id) as assigned FROM exp_ajw_client_downloads_folder f LEFT OUTER JOIN exp_ajw_client_downloads_users u ON u.folder_id = f.id";
		$sql .= " AND u.member_id = " . $IN->GBL("member_id");
		$sql .= " GROUP BY 1";
		$query = $DB->query($sql);
		$folders = "";
		foreach( $query->result as $row ) {
			if ( $row["assigned"] == 1 ) {
				$folders .= $DSP->input_select_option($row["id"], $row["title"], $row["assigned"]);
			} else {
				$folders .= $DSP->input_select_option($row["id"], $row["title"]);
			}
		}

		$r .= $DSP->tr();
		$r .= $DSP->td('tableCellTwo', '30%', '', '', 'top') .
			$DSP->qdiv('defaultBold', 'Select folders for ' . $member_name) .
			$DSP->td_c();
		$r .= $DSP->td('tableCellTwo', '', '', '', 'top') . 
					$DSP->input_select_header( 'folder[]', 'y', 8 ) . 
					$folders . 
					$DSP->input_select_footer() .
			$DSP->td_c();
			
		$r .= $DSP->tr_c();

		
		$r .= $DSP->table_c();

		$r .= $DSP->qdiv('itemWrapper', BR.$DSP->input_submit('Update assigned folders'));  

		$r .= $DSP->form_c();

		$DSP->body .= $r;
	}
	
	function update_user()
	{
		global $LANG, $DB, $IN, $DSP, $FNS, $LOC, $REGX, $EXT;

		if ( $IN->GBL("update") == "true" ) {
			
			// Do update
			
			// Update assigned folders

			$query = $DB->query("SELECT folder_id as id FROM exp_ajw_client_downloads_users WHERE member_id = " . $IN->GBL("member_id"));
			$current = array();
			foreach( $query->result as $row ) {
				$current[] = $row["id"];
			}
			
			$delete = $current;
			if ( is_array($IN->GBL("folder")) ) {
				$delete = array_diff( $current, $IN->GBL("folder"));
			}
			$insert = array();
			if ( is_array($IN->GBL("folder")) ) {
				$insert = array_diff( $IN->GBL("folder"), $current);
			}
			
			if ( count($delete) )	{
				$DB->query("DELETE FROM exp_ajw_client_downloads_users WHERE member_id = " . $IN->GBL("member_id") . " AND folder_id IN (" . join(",", $delete). ")");
			}

			if ( count($insert) )	{
				foreach($insert as $folder_id) {
					$data = array(
						"member_id" => $IN->GBL("member_id"), 
						"folder_id" => $folder_id, 
						"created" => $LOC->now
					);
					$DB->query( 
						$DB->insert_string( 
							"exp_ajw_client_downloads_users", 
							$data
						) 
					);
				}
			}
			
		} else {
			
			// Insert new user record
			
			// Validate

	    if ( $IN->GBL("create_default") == 'Yes' && $IN->GBL("folder_title") == '' )
	    {
	    	$DSP->body .= $DSP->error_message("The member's default folder must have a title");        
	      return;
	    } 

	    if ( $IN->GBL("create_default") == 'No' && $IN->GBL("folder") == '' )
	    {
	    	$DSP->body .= $DSP->error_message("The member must be assigned to a folder");        
	      return;
	    } 

			$folder_list = array();
			
			if( $IN->GBL("create_default") == "Yes" ) {
				$data = array(
					"title" => $IN->GBL("folder_title"), 
					"description" => "", 
					"created" => $LOC->now
				);
				$DB->query( 
					$DB->insert_string( 
						"exp_ajw_client_downloads_folder", 
						$data
					) 
				);
				$folder_list[] = $DB->insert_id;
			}
			
			if ( is_array( $IN->GBL("folder") ) ) {
				$folder_list = array_merge( $folder_list, $IN->GBL("folder") );
			}

			foreach($folder_list as $folder_id) {
				$data = array(
					"member_id" => $IN->GBL("member_id"), 
					"folder_id" => $folder_id, 
					"created" => $LOC->now
				);
				$DB->query( 
					$DB->insert_string( 
						"exp_ajw_client_downloads_users", 
						$data
					) 
				);
			}
			
			$user_id = $DB->insert_id;
			
			if ( ! class_exists('EEmail'))
			{
			    require PATH_CORE.'core.email'.EXT;
			}

			$query = $DB->query("SELECT * FROM exp_ajw_client_downloads_settings");

			if ( $query->row["email_body"] != "" ) { 
				$message = $query->row["email_body"];
				// $message = str_replace("{title}", $query->row["title"], $message);
				$from = $query->row["email_from"];
				$subject = $query->row["email_subject"];

				$email = new EEmail;
				$email->wordwrap = false;
				$email->mailtype = 'text';	

				$query = $DB->query("SELECT m.member_id, m.screen_name, m.email FROM exp_members m WHERE m.member_id = ". $IN->GBL("member_id") );
				if ( $query->num_rows > 0 ) {
					foreach ( $query->result as $row ) {
						if (preg_match( '/(.*)\<(.*)\>/', $from, $match)) {
							$email->from( trim($match[2]), trim($match[1]) );
						} else {
							$email->from( $from );
						}
						$email->to( $row["email"] ); 
						// $email->bcc( $PREFS->ini('webmaster_email') );
						$email->subject( $subject );
						$email->message($REGX->entities_to_ascii( $message ));		
						$email->Send();
						$email->initialize();
					}
				}
			}
			
			// -------------------------------------------
			// 'ajw_client_downloads_new_user' hook.
			//  - Take extra actions when new download area is set up
			//
			if (isset($EXT->extensions['ajw_client_downloads_new_user']))
			{
				$edata = $EXT->call_extension('ajw_client_downloads_new_user', $IN->GBL("member_id"));
				if ($EXT->end_script === TRUE) exit;
			}	
			//
			// -------------------------------------------
			
			
		}
		
		if ( $IN->GBL("RET") != "" ) {
			$FNS->redirect( $IN->GBL("RET") );
		} elseif( $IN->GBL("member_id") ) {
			$this->edit_user("Succesfully updated.");
		} else {
			$this->user("Succesfully added.");
		}
		
	}

	function delete_user() {
		global $LANG, $DB, $IN, $DSP, $FNS, $LOC;

		$id = $IN->GBL("member_id");

		if ( $IN->GBL("confirm") != "confirm" ) {

			$DSP->body = $DSP->delete_confirmation(
			array(
				'url'		=> 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=delete_user',
				'heading'	=> 'ajw_client_downloads_delete_user',
				'message'	=> 'ajw_client_downloads_delete_user_confirmation',
				'extra'		=> '',
				'hidden'	=> array('member_id' => $id, 'confirm' => "confirm")
				)
			);	

			return;

		} else {

			$DB->query("DELETE from exp_ajw_client_downloads_users WHERE member_id = " . $id);

		}

		$this->users();

	}

	function folders() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		// Page header

		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Folders");    

		$DSP->right_crumb( 'Create new folder', BASE.AMP.'C=modules'.AMP.'M='.$this->module_name.AMP.'P=edit_folder');

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";

		$r = "";

		$r .= $this->_navigation();

		if ( $IN->GBL("member_id") ) {
			// Displaying folders assigned to a specific user. Get some user details
			$sql = "SELECT member_id, screen_name FROM exp_members WHERE member_id = " . $IN->GBL("member_id");
			$query = $DB->query($sql);
			$member_name = $query->row["screen_name"];
			$r .= "<h1>Folders assigned to " . $member_name . "</h1>";
		} else {
			$r .= "<h1>Folders</h1>";			
		}

		$sql = "SELECT DISTINCT f.id, f.title, f.description FROM exp_ajw_client_downloads_folder f";
		if ( $IN->GBL("member_id") != "" ) {
			$sql .= ", exp_ajw_client_downloads_users u WHERE f.id = u.folder_id AND u.member_id = " . $IN->GBL("member_id");
		}

		if ( $IN->GBL("orderby") != "" ) {
			$sql .= " ORDER BY " . $IN->GBL("orderby");			
		} else {
			$sql .= " ORDER BY title";
		}
		if ( $IN->GBL("sort") != "" ) {
			$sql .= " " . $IN->GBL("sort");			
		} else {
			$sql .= " ASC";
		}
		
		$query = $DB->query($sql);

		if ( $IN->GBL("Export") == "Export" ) {
			
			// Do CSV export

			$output = "";
			foreach( $query->result as $row ) {
				unset( $row["id"] );
				$output .= '"' . join('","', $row) . '"' . "\n";
			}			
			
			header('Content-Type: application/vnd.ms-excel;');  
			header('Content-type: application/x-msexcel');  
			header('Content-Disposition: attachment; filename="export.csv"');
			print $output;
				
			exit;
			
		}
		
		$r .= $DSP->qdiv( 'tableHeading', 'List folders' ); 
		$r .= $DSP->div('box');
		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M=ajw_client_downloads'.AMP.'P=folders'
			)
		);

		if ( $IN->GBL("member_id") != "") {
			$r .= $DSP->input_hidden("member_id", $IN->GBL("member_id"));
		}
	
		
		$r .= "Sort: " . 
			$DSP->input_select_header("orderby") .
			$DSP->input_select_option("title", "Title") .
			$DSP->input_select_option("created", "Date") .
			$DSP->input_select_footer();

		$r .= $DSP->input_select_header("sort") .
			$DSP->input_select_option("asc", "Ascending") .
			$DSP->input_select_option("desc", "Descending") .
			$DSP->input_select_footer();
		
		$r .= $DSP->input_submit("Submit");
		
		$r .= $DSP->form_close();
		$r .= $DSP->div_c();
		
				
		$r .= $DSP->table('tableBorder', '0', '0', '100%') .
			$DSP->tr().
			$DSP->table_qcell('tableHeadingAlt',  array(
				'Title',
				'Description',
				'',
				'',
				''
				)
			) .
			$DSP->tr_c();

		$i = 0;

		$base_url = BASE.AMP.'C=modules'.AMP.'M='.$this->module_name.AMP;

		$group_name = '';
		foreach($query->result as $row)
		{
			$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

			$r .= $DSP->tr();

			$r .= $DSP->table_qcell($style, 
				$DSP->anchor( $base_url.'P=edit_folder'.AMP.'folder_id='.$row["id"], $row['title'], 'class="folder"'),
				'','top');	
			$r .= $DSP->table_qcell($style, $row['description'],'50%','top');	
			$r .= $DSP->table_qcell($style, 
				$DSP->anchor( $base_url.'P=assets'.AMP.'folder_id='.$row["id"], 'List assets', 'class="asset"')
				,'','top');
			$r .= $DSP->table_qcell($style, 
				$DSP->anchor( $base_url.'P=users'.AMP.'folder_id='.$row["id"], 'List users', 'class="user"')
				,'','top');
			$r .= $DSP->table_qcell($style, 
				$DSP->anchor( $base_url.'P=delete_folder'.AMP.'folder_id='.$row["id"], "Delete folder", 'class="delete"')
				,'','top');

			$r .= $DSP->tr_c();

		}
		$r .= $DSP->table_c();

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=folders', 
				'name' => 'export', 
				'id' => 'export'
			)
		);
		$r .= $DSP->input_hidden( 'orderby', $IN->GBL("orderby") ); 
		$r .= $DSP->input_hidden( 'member_id', $IN->GBL("member_id") ); 
		$r .= $DSP->input_hidden( 'query', $IN->GBL("query") ); 
		$r .= $DSP->input_hidden( 'sort', $IN->GBL("sort") ); 
		$r .= $DSP->qdiv('itemWrapper', BR.$DSP->input_submit('Export', "Export")); 
		$r .= $DSP->form_close();
		
		$DSP->body .= $r;
	}

	function edit_folder($msg="") {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Edit folder");    

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";
		$DSP->extra_header .= "\n<script type='text/javascript' src='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/js/ajw_client_downloads.js'></script>";

		$r = "";

		$r .= $this->_navigation("folders");

		$r .= "<h1>Edit folder</h1>";

		if ($msg != '')
		{
			$r .= $DSP->qdiv('successBox', $DSP->qdiv('success', $msg)) . BR;
		}

		if ( $IN->GBL("folder_id") != "" ) {
			// Error

			$sql = "SELECT id, title, description, created FROM exp_ajw_client_downloads_folder WHERE id = " . $DB->escape_str( $IN->GBL("folder_id") );
			$query = $DB->query($sql);

			if ( $query->num_rows > 0 ) {
				$title = $query->row["title"];
				$description = $query->row["description"];
			}
			
		} else {
			
			$title = "";
			$description = "";
			
		}
			
		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP  .'M='.$this->module_name.AMP.'P=update_folder', 
				'name' => 'edit_folder', 
				'id' => 'edit_folder'
			)
		);

		if ( $IN->GBL("folder_id") != "" ) {
			$r .= $DSP->input_hidden( 'folder_id', $IN->GBL("folder_id") ); 
		}

		$r .= $DSP->qdiv( 'tableHeading', 'Edit folder' ); 
		$r .= $DSP->table('tableBorder', '0', '0', '100%');

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 'Title', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('title', $title, '35', '255', 'input', '45%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->td('tableCellTwo', '', '', '', 'top') .
			$DSP->qdiv('defaultBold', 'Description', '30%') .
			$DSP->td_c();
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
				$DSP->input_textarea('description', $description, 6, 'textarea', '75%')
,
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->td('tableCellOne', '', 2);

		$r .= $DSP->table('', '0', '0', '100%');
		$r .= $DSP->tr();
		
		$all = "";
		$assigned = ""; 
		$assets = array();
		$sql = "SELECT  a.*, fa.folder_id FROM  exp_ajw_client_downloads_asset a LEFT OUTER JOIN exp_ajw_client_downloads_folder_assets fa ON fa.asset_id = a.id";
		if ( $IN->GBL("folder_id") != "" ) {
			$sql .= " AND folder_id = " . $IN->GBL("folder_id");
		} else {
			$sql .= " AND folder_id = 0 ";
		}
		$sql .= " ORDER BY title";
		$subquery = $DB->query($sql);
		foreach( $subquery->result as $row ) {
			if ( $row["folder_id"] != NULL ) {
				$assigned .= $DSP->input_select_option($row["id"], $row["title"]);
				$assets[] = $row["id"];
			} else {
				$all .= $DSP->input_select_option($row["id"], $row["title"]);
			}
		}
		
		$r .= $DSP->table_qcell(
			'',
			$DSP->qdiv('defaultBold', 'Available assets') .
			$DSP->input_select_header('all[]', 'y', 8, '100%', 'id="sourceList"') .
			$all .
			$DSP->input_select_footer(), '50%'
		);

		$r .= $DSP->table_qcell(
			'',
			$DSP->input_submit('Add', 'Add', 'style="width:100px;margin: 0 10px" id="addButton"') . BR .
			$DSP->input_submit('Remove', 'Remove', 'style="width:100px; margin: 0 10px" id="removeButton"')
		);

		
		$r .= $DSP->table_qcell(
			'',
			$DSP->qdiv('defaultBold', 'Assets in this folder') .
			$DSP->input_select_header('assigned[]', 'y', 8, '100%', 'id="selectedList"') .
			$assigned .
			$DSP->input_select_footer() .
			$DSP->input_hidden('original_assets', join(",", $assets) ) .
			$DSP->input_hidden('assets', join(",", $assets), 'id="assets"' ),
			'50%'
		);
		
		$r .= $DSP->tr_c();
		$r .= $DSP->table_c();

		$r .= $DSP->td_c();

		$r .= $DSP->tr_c();


		$r .= $DSP->table_c();

		$r .= $DSP->qdiv('itemWrapper', BR.$DSP->input_submit('Update', 'Submit'));  

		$r .= $DSP->form_c();			

		$DSP->body .= $r;

	} 

	function update_folder() {
		global $LANG, $DB, $IN, $DSP, $FNS, $LOC;

		$id = $IN->GBL("folder_id");

    if ( $IN->GBL("title") == '')
    {
    	$DSP->body .= $DSP->error_message("Folder must a have a title");        
      return;
    } 

		if ( $id != "" ) {
			
			// Do update
			
			$data = array(
				"title" => $IN->GBL("title"), 
				"description" => $IN->GBL("description")
			);
			$DB->query( 
				$DB->update_string( 
					"exp_ajw_client_downloads_folder", 
					$data, 
					"id = " . $DB->escape_str( $id )
				)
			);

		} else {
			
			// Insert new asset record
			
			$data = array(
				"title" => $IN->GBL("title"), 
				"description" => $IN->GBL("description"),
				"created" => $LOC->now
			);

			$DB->query( 
				$DB->insert_string( 
					"exp_ajw_client_downloads_folder", 
					$data
				) 
			);
			
			$id = $DB->insert_id;
			
		}

		if ( $IN->GBL("assets") !=  $IN->GBL("original_assets") ) {
			
			$current = split(",", $IN->GBL("original_assets"));
			$new = split(",", $IN->GBL("assets"));

			if ( $IN->GBL("original_assets") == ""  ) {
				$current = array();
			}

			$delete = $current;				
			if ( is_array($new) ) {
				$delete = array_diff( $current, $new );
			}
			$insert = array();
			if ( is_array($new) ) {
				$insert = array_diff( $new, $current );
			}
			
			if ( count($delete) )	{
				$DB->query("DELETE FROM exp_ajw_client_downloads_folder_assets WHERE folder_id = " . $id . " AND asset_id IN (" . join(",", $delete). ")");
			}

			if ( count($insert) )	{
				foreach($insert as $asset_id) {
					$data = array(
						"asset_id" => $asset_id, 
						"folder_id" => $id, 
						"created" => $LOC->now
					);
					$DB->query( 
						$DB->insert_string( 
							"exp_ajw_client_downloads_folder_assets", 
							$data
						) 
					);
				}
			}
			
		}

		if ( $IN->GBL("Add") == "Add" || $IN->GBL("Remove") == "Remove" ) {
			if ( $IN->GBL("Add") == "Add" && is_array($IN->GBL("all")) ) {
				foreach ( $IN->GBL("all") as $asset_id ) {
					$data = array(
						"asset_id" => $asset_id,
						"folder_id" => $id,
						"created" => $LOC->now
					);
					$DB->query($DB->insert_string("exp_ajw_client_downloads_folder_assets", $data));
				}
			}
			if ( $IN->GBL("Remove") == "Remove"  && is_array($IN->GBL("assigned")) ) {
				foreach ( $IN->GBL("assigned") as $asset_id ) {
					$DB->query("DELETE FROM exp_ajw_client_downloads_folder_assets WHERE asset_id = " . $asset_id . " AND folder_id = " . $id);
				}
			}
		}
		
		if ( $IN->GBL("folder_id") ) {
			$this->edit_folder("Folder updated");		
		} else {
			$this->folders();
		}
		
	}

	function delete_folder() {
		global $LANG, $DB, $IN, $DSP, $FNS, $LOC;

		$id = $IN->GBL("folder_id");

		if ( $IN->GBL("confirm") != "confirm" ) {
			
			$DSP->body = $DSP->delete_confirmation(
				array(
					'url'		=> 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=delete_folder',
					'heading'	=> 'ajw_client_downloads_delete_folder',
					'message'	=> 'ajw_client_downloads_delete_folder_confirmation',
					'extra'		=> '',
					'hidden'	=> array('folder_id' => $id, 'confirm' => "confirm")
				)
			);	

			return;
			
		} else {

			$DB->query("DELETE from exp_ajw_client_downloads_folder WHERE id = " . $id);
			$DB->query("DELETE from exp_ajw_client_downloads_users WHERE folder_id = " . $id);

		}

		$this->folders();
		
	}

	function assets() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		// Page header

		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->crumb .= $DSP->crumb_item("View assets");    

		$DSP->right_crumb( 'Upload new asset', BASE.AMP.'C=modules'.AMP.'M='.$this->module_name.AMP.'P=upload_asset');

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";

		$r = "";

		$r .= $this->_navigation();

		if ( $IN->GBL("folder_id") ) {
			// Displaying folders assigned to a specific user. Get some user details
			$sql = "SELECT title FROM exp_ajw_client_downloads_folder WHERE id = " . $IN->GBL("folder_id");
			$query = $DB->query($sql);
			$folder_title = $query->row["title"];
			$r .= "<h1>Assets in the folder: " . $folder_title . "</h1>";
		} else {
			$r .= "<h1>Assets</h1>";			
		}
		
		$sql = "SELECT a.id, a.title, a.path, a.created, CONCAT( s.basepath, a.path )  AS fullpath,  COUNT(l.id) as downloads FROM exp_ajw_client_downloads_asset a JOIN exp_ajw_client_downloads_settings s LEFT OUTER JOIN exp_ajw_client_downloads_log l ON a.id = l.asset_id";
		if ( $IN->GBL("folder_id") != "" ) {
			$sql .= "  LEFT OUTER JOIN exp_ajw_client_downloads_folder_assets fa ON fa.asset_id = a.id";
			$sql .= " WHERE fa.folder_id = " . $DB->escape_str( $IN->GBL("folder_id") );
		}
		if ( $IN->GBL("query") != "" ) {		
		 $sql .= " WHERE CONCAT(a.title, a.description, a.keywords) LIKE \"%" . $IN->GBL("query") . "%\"";
		}
		$sql .= " GROUP BY 1";
		
		$query = $DB->query($sql);

		$row_limit = 25;
		$row_count = ( ! $IN->GBL('row')) ? 0 : $IN->GBL('row');

		$paginate = "";
		if ($query->num_rows > $row_limit)
		{						
			$url = BASE.AMP.'C=modules'.AMP.'M='.$this->module_name.AMP.'P=assets';

			$paginate = $DSP->pager($url,
				$query->num_rows,
				$row_limit,
				$row_count,
				'row'
				); 
		}

		if ( $IN->GBL("orderby") != "" ) {
			$sql .= " ORDER BY " . $IN->GBL("orderby");			
		} else {
			$sql .= " ORDER BY created";
		}
		if ( $IN->GBL("sort") != "" ) {
			$sql .= " " . $IN->GBL("sort");			
		} else {
			$sql .= " DESC";
		}

		$sql .= " LIMIT " . $row_count . "," . $row_limit;
		$query = $DB->query($sql);

		if ( $IN->GBL("Export") == "Export" ) {
			
			// Do CSV export

			$output = "";
			foreach( $query->result as $row ) {
				$extension = "none";
				preg_match("/\.([a-zA-Z]{2,4})$/", $row["fullpath"], $extensions);
				if( isset( $extensions[1] ) ) {
					$extension = $extensions[1];
				}
				$row["extension"] = $extension;
				$row["size"] = $this->_size(filesize($row['fullpath']));
				$row["created"] = $this->_date($row['created']);
				unset( $row["id"] );
				unset( $row["fullpath"] );
				$output .= '"' . join('","', $row) . '"' . "\n";
			}			
						
			header('Content-Type: application/vnd.ms-excel;');  
			header('Content-type: application/x-msexcel');  
			header('Content-Disposition: attachment; filename="export.csv"');
			print $output;
				
			exit;
			
		}

		$r .= $DSP->qdiv( 'tableHeading', 'List assets' ); 
		$r .= $DSP->div('box');
		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M=ajw_client_downloads'.AMP.'P=assets'
			)
		);

	$r .= "Search for: " . 
		$DSP->input_text('query', '', '20', '', 'input', '');
		
		$r .= "Sort: " . 
			$DSP->input_select_header("orderby") .
			$DSP->input_select_option("title", "Title") .
			$DSP->input_select_option("path", "Filename") .
			$DSP->input_select_option("created", "Date") .
			$DSP->input_select_option("downloads", "Downloads") .
			$DSP->input_select_footer();

		$r .= $DSP->input_select_header("sort") .
			$DSP->input_select_option("asc", "Ascending") .
			$DSP->input_select_option("desc", "Descending") .
			$DSP->input_select_footer();
		
		$r .= $DSP->input_submit("Submit");
		
		$r .= $DSP->form_close();
		$r .= $DSP->div_c();

		$r .= $DSP->table('tableBorder', '0', '0', '100%') .
			$DSP->tr().
			$DSP->table_qcell('tableHeadingAlt',  array(
				'Title',
				'Filename',
				'Filetype',
				'Size',
				'Upload Date',
				'Downloads',
				''
				)
			) .
			$DSP->tr_c();

		$i = 0;

		$base_url = BASE.AMP.'C=modules'.AMP.'M='.$this->module_name.AMP;

		if ( $query->num_rows == 0 ) {
			$r .= $DSP->tr();
			$r .= $DSP->td('tableCellOne', '', 5) . "This folder has no assets assigned" . $DSP->td_c();
			$r .= $DSP->tr_c();			
		}

		$group_name = '';
		foreach($query->result as $row)
		{
			$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

			$r .= $DSP->tr();

			$r .= $DSP->table_qcell($style, 
				$DSP->anchor($base_url."P=edit_asset".AMP."asset_id=".$row["id"], $row['title'], 'class="asset"'),
				'','top');
			$r .= $DSP->table_qcell($style, $row["path"],'','top');
			$extension = "none";
			preg_match("/\.([a-zA-Z]{2,4})$/", $row["fullpath"], $extensions);
			if( isset( $extensions[1] ) ) {
				$extension = $extensions[1];
			}
			$r .= $DSP->table_qcell($style, $extension,'','top');
			$r .= $DSP->table_qcell($style, $this->_size(filesize($row['fullpath'])),'','top');
			$r .= $DSP->table_qcell($style, $this->_date($row['created']),'','top');
			$r .= $DSP->table_qcell($style, $row['downloads'],'','top');
			$r .= $DSP->table_qcell($style, 
				$DSP->anchor($base_url ."P=delete_asset".AMP."asset_id=".$row["id"], "Delete", 'class="delete"')
				,'','top');

			$r .= $DSP->tr_c();

		}
		$r .= $DSP->table_c();

		$r .= $paginate;

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=assets', 
				'name' => 'export', 
				'id' => 'export'
			)
		);
		$r .= $DSP->input_hidden( 'orderby', $IN->GBL("orderby") ); 
		$r .= $DSP->input_hidden( 'folder_id', $IN->GBL("folder_id") ); 
		$r .= $DSP->input_hidden( 'query', $IN->GBL("query") ); 
		$r .= $DSP->input_hidden( 'sort', $IN->GBL("sort") ); 
		$r .= $DSP->qdiv('itemWrapper', BR.$DSP->input_submit('Export', "Export")); 
		$r .= $DSP->form_close();


		$DSP->body .= $r;
	}

	function edit_asset( $msg = "" ) {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Edit asset");    

		$DSP->right_crumb( 'Upload new asset', BASE.AMP.'C=modules'.AMP.'M='.$this->module_name.AMP.'P=upload_asset');

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";

		$r = "";

		$r .= $this->_navigation("assets");

		$r .= "<h1>Edit asset</h1>";

		if ($msg != '')
		{
			$r .= $DSP->qdiv('successBox', $DSP->qdiv('success', $msg)) . BR;
		}

		if ( $IN->GBL("asset_id") == "" ) {
			// Error
			
		} else {
			
			$sql = "SELECT a.id, a.title, a.path, a.created, a.description, a.keywords FROM exp_ajw_client_downloads_asset a WHERE id = " . $DB->escape_str( $IN->GBL("asset_id") );
			$query = $DB->query($sql);
			
			if ( $query->num_rows > 0 ) {
			
				$r .= $DSP->form_open(
					array(
						'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=update_asset', 
						'enctype' => "multipart/form-data", 
						'name' => 'edit_asset', 
						'id' => 'edit_asset'
					)
				);

				$r .= $DSP->input_hidden( 'asset_id', $IN->GBL("asset_id") ); 
				$r .= $DSP->input_hidden( 'path', $query->row["path"] ); 

				$r .= $DSP->qdiv( 'tableHeading', 'Edit asset' ); 
				$r .= $DSP->table('tableBorder', '0', '0', '100%');

				$r .= $DSP->tr();
				$r .= $DSP->table_qcell(
					'tableCellOne', 
					$DSP->qdiv('defaultBold', 'Title', '30%') 
				);
				$r .= $DSP->table_qcell(
					'tableCellOne', 
					$DSP->qdiv('defaultBold', 
						$DSP->qdiv('itemWrapper', 
							$DSP->input_text('title', $query->row["title"], '35', '255', 'input', '45%')
						)
					),
					'70%'
				);
				$r .= $DSP->tr_c();

				$r .= $DSP->tr();
				$r .= $DSP->table_qcell(
					'tableCellTwo', 
					$DSP->qdiv('defaultBold', 'Description', '30%') 
				);
				$r .= $DSP->table_qcell(
					'tableCellTwo', 
					$DSP->qdiv('defaultBold', 
						$DSP->qdiv('itemWrapper', 
							$DSP->input_textarea('description', $query->row["description"], 6, 'textarea', '75%')
						)
					),
					'70%'
				);
				$r .= $DSP->tr_c();
				
				$r .= $DSP->tr();
				$r .= $DSP->table_qcell(
					'tableCellOne', 
					$DSP->qdiv('defaultBold', 'Keywords', '30%') 
				);
				$r .= $DSP->table_qcell(
					'tableCellOne', 
					$DSP->qdiv('defaultBold', 
						$DSP->qdiv('itemWrapper', 
							$DSP->input_text('keywords', $query->row["keywords"], '35', '255', 'input', '45%')
						)
					),
					'70%'
				);
				$r .= $DSP->tr_c();
								
				$r .= $DSP->tr();
				$r .= $DSP->table_qcell(
					'tableCellTwo', 
					$DSP->qdiv('defaultBold', 'Uploaded', '30%') 
				);
				$r .= $DSP->table_qcell(
					'tableCellTwo', 
					$DSP->qdiv('defaultBold', 
						$DSP->qdiv('itemWrapper', 
							$this->_date($query->row["created"])
						)
					),
					'70%'
				);
				$r .= $DSP->tr_c();

				$sql = "SELECT f.id, f.title, count(fa.id) as selected FROM exp_ajw_client_downloads_folder f LEFT  OUTER  JOIN exp_ajw_client_downloads_folder_assets fa ON fa.folder_id = f.id AND fa.asset_id = " . $DB->escape_str($IN->GBL("asset_id")) . " GROUP BY 1";
				$query = $DB->query($sql);
				$folders = "";
				foreach( $query->result as $row ) {
					if ( $row["selected"] ) {
						$folders .= $DSP->input_select_option($row["id"], $row["title"], $row["selected"]);
					} else {
						$folders .= $DSP->input_select_option($row["id"], $row["title"]);
					}
				}

				$r .=	$DSP->tr();

				$r .= $DSP->td('tableCellOne', '', '', '', 'top') .
					$DSP->qdiv('defaultBold', 'Add to existing folders', '30%') .
					$DSP->td_c();
				$r .= $DSP->td('tableCellOne', '', '', '', 'top') . 
							$DSP->input_select_header( 'folder[]', 'y', 8 ) . 
							$folders . 
							$DSP->input_select_footer() .
					$DSP->td_c();

				$r .=	$DSP->tr_c();


				$r .= $DSP->tr();
				$r .= $DSP->table_qcell(
					'tableCellTwo', 
					$DSP->qdiv('defaultBold', 'Replace asset with new file', '30%') 
				);
				$r .= $DSP->table_qcell(
					'tableCellTwo', 
					$DSP->qdiv('defaultBold', 
						$DSP->qdiv('itemWrapper', '<input type="file" name="file_upload" />')
					),
					'70%'
				);
				$r .= $DSP->tr_c();      


				$r .= $DSP->table_c();

				$r .= $DSP->qdiv('itemWrapper', BR.$DSP->input_submit('Update'));  

				$r .= $DSP->form_c();			
			}
		
		}

		$DSP->body .= $r;
	}
	
	function update_asset($basepath="", $filename="")
	{
		global $LANG, $DB, $IN, $DSP, $FNS, $LOC, $REGX;

		if($_FILES['file_upload']['name'] != "") {

			$upload_error = array(
			    UPLOAD_ERR_INI_SIZE => 'The uploaded file exceeds the upload_max_filesize directive in php.ini.',
			    UPLOAD_ERR_FORM_SIZE => 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.',
			    UPLOAD_ERR_PARTIAL => 'The uploaded file was only partially uploaded.',
			    UPLOAD_ERR_NO_FILE => 'No file was uploaded.',
			    UPLOAD_ERR_NO_TMP_DIR => 'Missing a temporary folder.',
			    UPLOAD_ERR_CANT_WRITE => 'Failed to write file to disk.'
			);

			if($_FILES['file_upload']['error'] !== UPLOAD_ERR_OK)
			{
				$DSP->body .= $DSP->error_message($upload_error[ $_FILES['file_upload']['error'] ]);        
	      return;
			}

			$filename = $_FILES['file_upload']['name'];

		}
		
		$asset_id = $IN->GBL("asset_id");

    if ( $IN->GBL("title") == '')
    {
    	$DSP->body .= $DSP->error_message("Asset must have a title");        
      return;
    } 

		if ( $asset_id != "" ) {
			
			// Do update

			$path = $IN->GBL("path");
			
			$file = $_FILES['file_upload']['name'];
			if( $file != "" )
			{
				// Move file
				$query = $DB->query("SELECT basepath FROM exp_ajw_client_downloads_settings");
				$basepath = $query->row['basepath'];
				$target_path = $basepath . $asset_id . "_" . $file;
				unlink($basepath . $path);
				if( move_uploaded_file($_FILES['file_upload']['tmp_name'], $target_path) ) {
					chmod($target_path, 0666);				
					// Add to asset table
					$path = $asset_id . "_" . $file;
				}
			}

			$data = array(
				"title" => $IN->GBL("title"), 
				"description" => $IN->GBL("description"), 
				"keywords" => $IN->GBL("keywords"), 
				"path" => $path, 
			);
			$DB->query( 
				$DB->update_string( 
					"exp_ajw_client_downloads_asset", 
					$data, 
					"id = " . $DB->escape_str( $asset_id )
				)
			);

		} else {
			
			// Insert new asset record
			
			$data = array(
				"title" => $IN->GBL("title"), 
				"description" => $IN->GBL("description"), 
				"keywords" => $IN->GBL("keywords"), 
				"path" => $filename, 
				"created" => $LOC->now
			);
			$DB->query( 
				$DB->insert_string( 
					"exp_ajw_client_downloads_asset", 
					$data
				) 
			);
			
			$asset_id = $DB->insert_id;

			$data = array(
				"path" => $asset_id . "_" . $filename
			);
			$DB->query( 
				$DB->update_string( 
					"exp_ajw_client_downloads_asset", 
					$data,
					"id = " . $asset_id
				) 
			);
			rename( 
				$basepath . $filename, 
				$basepath . $asset_id . "_" . $filename
			);
			
		}
		
		$DB->query("DELETE FROM exp_ajw_client_downloads_folder_assets WHERE asset_id = " . $DB->escape_str( $asset_id ) );
		if ( $IN->GBL("folder") != "" ) {
			foreach( $IN->GBL("folder") as $folder_id ) {
				$data = array(
					"folder_id" => $folder_id,
					"asset_id" => $DB->escape_str( $asset_id ),
					"created" => $LOC->now
					);
				$DB->query( $DB->insert_string( "exp_ajw_client_downloads_folder_assets", $data ) );
			}
		}
		
		if ( $IN->GBL("notify") == "yes" ) {
			// Email notification to all members

			if ( ! class_exists('EEmail'))
			{
			    require PATH_CORE.'core.email'.EXT;
			}

			$query = $DB->query("SELECT * FROM exp_ajw_client_downloads_settings");

			if ( $query->row["new_asset_email_body"] != "" ) {

				$message = $query->row["new_asset_email_body"];
				$from = $query->row["new_asset_email_from"];
				$subject = $query->row["new_asset_email_subject"];

				$email = new EEmail;
				$email->wordwrap = false;
				$email->mailtype = 'text';	
			
				$query = $DB->query("SELECT DISTINCT a.title, 
					a.description, 
					u.member_id, 
					m.screen_name, 
					m.email
				FROM exp_ajw_client_downloads_folder_assets fa INNER JOIN exp_ajw_client_downloads_asset a ON fa.asset_id = a.id
					 INNER JOIN exp_ajw_client_downloads_users u ON fa.folder_id = u.folder_id
					 INNER JOIN exp_members m ON u.member_id = m.member_id
				WHERE a.id = " . $asset_id );

				$message = str_replace( '{title}', $query->row["title"], $message);
			
				if ( $query->num_rows > 0 ) {
					foreach($query->result as $row) {
						if (preg_match( '/(.*)\<(.*)\>/', $from, $match)) {
							$email->from( trim($match[2]), trim($match[1]) );
						} else {
							$email->from( $from );
						}
						$email->to( $row["email"] ); 
						// $email->bcc( $PREFS->ini('webmaster_email') );
						$email->subject( $subject );
						$email->message($REGX->entities_to_ascii( $message ));		
					
						$email->Send();
						$email->initialize();	
					}
				}
			}
			
		}
		

		if ( $IN->GBL("RET") != "" ) {
			$FNS->redirect( $IN->GBL("RET") );
		} elseif( $IN->GBL("asset_id") ) {
			$this->edit_asset("Succesfully updated.");
		} else {
			$this->assets("Succesfully added.");
		}
		
		
	}

	function delete_asset($basepath="")
	{
		global $LANG, $DB, $IN, $DSP, $FNS, $LOC;

		$asset_id = $IN->GBL("asset_id");

		$query = $DB->query("SELECT basepath FROM exp_ajw_client_downloads_settings");
		$basepath = $query->row['basepath'];

		$query = $DB->query("SELECT * FROM exp_ajw_client_downloads_asset WHERE id = " . $DB->escape_str($asset_id));

		if ( $IN->GBL("confirm") != "confirm" ) {
			
			$DSP->body = $DSP->delete_confirmation(
				array(
					'url'		=> 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=delete_asset',
					'heading'	=> 'ajw_client_downloads_delete_asset',
					'message'	=> 'ajw_client_downloads_delete_asset_confirmation',
					'extra'		=> '',
					'hidden'	=> array('asset_id' => $asset_id, 'confirm' => "confirm")
				)
			);	

			return;
			
		} else {

			unlink( $basepath . $query->row["path"]);
			
			$DB->query("DELETE FROM exp_ajw_client_downloads_asset WHERE id = " . $DB->escape_str($asset_id));
			$DB->query("DELETE FROM exp_ajw_client_downloads_folder_assets WHERE asset_id = " . $DB->escape_str($asset_id));
			$DB->query("DELETE FROM exp_ajw_client_downloads_log WHERE asset_id = " . $DB->escape_str($asset_id));

		}
	
		$this->assets("Asset deleted");		
	}

	function upload_asset() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN, $REGX;

		// Page header

		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Upload new asset");    

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";

		$r = "";

		$r .= $this->_navigation("assets");

		$r .= "<h1>Upload asset</h1>";

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=upload_file', 
				'enctype' => "multipart/form-data", 
				'name' => 'file_upload', 
				'id' => 'file_upload'
			)
		);

		$r .= $DSP->qdiv( 'tableHeading', 'Upload asset' ); 
		$r .= $DSP->table('tableBorder', '0', '0', '100%');

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 'Title', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('title', "", '35', '255', 'input', '45%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();
		
		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 'Description', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_textarea('description', '', 6, 'textarea', '75%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();
		
		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 'Keywords', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('keywords', '', '35', '255', 'input', '45%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();
		
		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 'File to upload', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', '<input type="file" name="file_upload" />')
			),
			'70%'
		);
		$r .= $DSP->tr_c();      

		$query = $DB->query("SELECT temp_path FROM exp_ajw_client_downloads_settings");

		if ( $query->row["temp_path"] != "" ) {

			$files = "";

			if ($handle = opendir($query->row["temp_path"])) {
				$filesArray = array();
				while (false !== ($file = readdir($handle))) {
					if (is_file( $query->row["temp_path"] . $file )) {
						$filesArray[] = $file;
					}
				}
				closedir($handle);
				natcasesort( $filesArray );
				foreach($filesArray as $file) {
						$files .= $DSP->input_select_option($file, $file);
				}
			}
			
			$r .= $DSP->tr();
			$r .= $DSP->table_qcell(
				'tableCellTwo', 
				$DSP->qdiv('defaultBold', 'Choose file', '30%') 
			);
			$r .= $DSP->table_qcell(
				'tableCellTwo', 
				$DSP->qdiv('defaultBold', 
					$DSP->qdiv('itemWrapper', 
					$DSP->input_select_header( 'file', 'yes', 8 ) . 
					$files . 
					$DSP->input_select_footer() 
					)
				),
				'70%'
			);
			$r .= $DSP->tr_c();      
		
		}

		$sql = "SELECT f.id, f.title FROM exp_ajw_client_downloads_folder f LEFT  OUTER  JOIN exp_ajw_client_downloads_folder_assets fa ON fa.folder_id = f.id GROUP BY 1";
		$query = $DB->query($sql);
		$folders = "";
		foreach( $query->result as $row ) {
			$folders .= $DSP->input_select_option($row["id"], $row["title"]);
		}

		$r .= $DSP->tr();
		$r .= $DSP->td('tableCellOne', '', '', '', 'top') .
			$DSP->qdiv('defaultBold', 'Add to folders', '30%') .
			$DSP->td_c();
		$r .= $DSP->td('tableCellOne', '', '', '', 'top') . 
					$DSP->input_select_header( 'folder[]', 'y', 8 ) . 
					$folders . 
					$DSP->input_select_footer() .
			$DSP->td_c();
			
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->td('tableCellTwo', '', '', '', 'top') .
			$DSP->qdiv('defaultBold', 'Notify users of new file?', '30%') .
			$DSP->td_c();
		$r .= $DSP->td('tableCellTwo', '', '', '', 'top') . 
					$DSP->input_checkbox( 'notify', 'yes' ) . 
			$DSP->td_c();
			
		$r .= $DSP->tr_c();
		
		$r .= $DSP->table_c();

		$r .= $DSP->qdiv('itemWrapper', BR.$DSP->input_submit('Upload file'));  

		$r .= $DSP->form_c();

		$DSP->body .= $r;
	}

	function upload_file()
	{
		global $LANG, $DB, $IN, $DSP, $FNS, $LOC;

		if( $_FILES['file_upload']['error'] === UPLOAD_ERR_NO_FILE && $IN->GBL("file") == "" ) {
			$DSP->body .= $DSP->error_message("You must choose a file to upload");        
			return;
		}

		$query = $DB->query("SELECT basepath, temp_path FROM exp_ajw_client_downloads_settings");
		$basepath = $query->row['basepath'];

		$upload_error = array(
		    UPLOAD_ERR_INI_SIZE => 'The uploaded file exceeds the upload_max_filesize directive in php.ini.',
		    UPLOAD_ERR_FORM_SIZE => 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.',
		    UPLOAD_ERR_PARTIAL => 'The uploaded file was only partially uploaded.',
		    UPLOAD_ERR_NO_FILE => 'No file was uploaded.',
		    UPLOAD_ERR_NO_TMP_DIR => 'Missing a temporary folder.',
		    UPLOAD_ERR_CANT_WRITE => 'Failed to write file to disk.'
		);

		if( $_FILES['file_upload']['error'] !== UPLOAD_ERR_NO_FILE ) {

			if($_FILES['file_upload']['error'] !== UPLOAD_ERR_OK)
			{
				$DSP->body .= $DSP->error_message($upload_error[ $_FILES['file_upload']['error'] ]);        
	      return;
			}

			$file = $_FILES['file_upload']['name'];
			if( $file != "" )
			{
				// Move file
				$target_path = $basepath . $file;
				if( move_uploaded_file($_FILES['file_upload']['tmp_name'], $target_path) ) {
					chmod($target_path, 0666);				
					// Add to asset table
					$this->update_asset($basepath);
				}
			}

		} elseif( $IN->GBL("file") != "" ) {
			
			$file = $IN->GBL("file");
			$target_path = $basepath . $file;
			rename( $query->row["temp_path"] . $file, $target_path );
			$this->update_asset($basepath, $file);
			
		}

	}
	
	function reports() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		// Page header

		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Download log");    

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";

		$r = "";

		$r .= $this->_navigation();

		$r .= "<h1>Reports</h1>";

		$sql = "SELECT a.title, m.screen_name, l.created FROM exp_ajw_client_downloads_log l, exp_members m, exp_ajw_client_downloads_asset a WHERE a.id = l.asset_id AND l.member_id = m.member_id";
		if ( $IN->GBL("member_id") != "" ) {
			$sql .= " AND m.member_id = " . $IN->GBL("member_id");
		}
		if ( $IN->GBL("folder_id") != "" ) {
			$sql .= " AND f.id = " . $IN->GBL("folder_id");
		}
		if ( $IN->GBL("asset_id") != "" ) {
			$sql .= " AND a.id = " . $IN->GBL("asset_id");
		}		
		$query = $DB->query($sql);

		$row_limit = 50;
		$row_count = ( ! $IN->GBL('row')) ? 0 : $IN->GBL('row');

		$paginate = "";
		if ($query->num_rows > $row_limit)
		{						
			$url = BASE.AMP.'C=modules'.AMP.'M='.$this->module_name.AMP.'P=reports';

			$paginate = $DSP->pager($url,
				$query->num_rows,
				$row_limit,
				$row_count,
				'row'
				); 
		}

		if ( $IN->GBL("folder_id") != "" ) {
			$sql .= " WHERE fa.folder_id = " . $DB->escape_str( $IN->GBL("folder_id") );
		}
		$sql .= " ORDER BY created DESC";
		$sql .= " LIMIT " . $row_count . "," . $row_limit;
		$query = $DB->query($sql);

		if ( $IN->GBL("Export") == "Export" ) {
			
			// Do CSV export

			$output = "";
			foreach( $query->result as $row ) {
				$row["created"] = $LOC->set_human_time( $row["created"] );
				unset( $row["id"] );
				$output .= '"' . join('","', $row) . '"' . "\n";
			}			
			
			header('Content-Type: application/vnd.ms-excel;');  
			header('Content-type: application/x-msexcel');  
			header('Content-Disposition: attachment; filename="export.csv"');
			print $output;
				
			exit;
			
		}
		
		$r .= $DSP->qdiv( 'tableHeading', 'Downloads' ); 
		$r .= $DSP->table('tableBorder', '0', '0', '100%') .
			$DSP->tr().
			$DSP->table_qcell('tableHeadingAlt',  array(
				'File downloaded',
				'By:',
				'Time'
				)
			) .
			$DSP->tr_c();

		$i = 0;

		$base_url = BASE.AMP.'C=modules'.AMP.'M='.$this->module_name.AMP;

		$group_name = '';
		foreach($query->result as $row)
		{
			$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

			$r .= $DSP->tr();

			$r .= $DSP->table_qcell($style, $row['title'],'','top');	
			$r .= $DSP->table_qcell($style, $row['screen_name'],'','top');
			$r .= $DSP->table_qcell($style, $this->_date($row['created']),'','top');	

			$r .= $DSP->tr_c();

		}
		$r .= $DSP->table_c();

		if ( $paginate != "" ) {
			$r .= $paginate;
		}

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=reports', 
				'name' => 'export', 
				'id' => 'export'
			)
		);
		$r .= $DSP->input_hidden( 'member_id', $IN->GBL("member_id") ); 
		$r .= $DSP->input_hidden( 'folder_id', $IN->GBL("folder_id") ); 
		$r .= $DSP->input_hidden( 'asset_id', $IN->GBL("asset_id") ); 
		$r .= $DSP->qdiv('itemWrapper', BR.$DSP->input_submit('Export', "Export")); 
		$r .= $DSP->form_close();
		
		$DSP->body .= $r;
	}	
	
	function settings( $msg = "" ) {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		// Page header

		$DSP->title = $LANG->line('ajw_client_downloads_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=ajw_client_downloads',
			$LANG->line('ajw_client_downloads_module_name'));

		$DSP->extra_header .= "\n<link rel='stylesheet' type='text/css' media='screen' href='/".$PREFS->ini('system_folder', TRUE)."modules/ajw_client_downloads/css/ajw_client_downloads.css' />";

		$query = $DB->query("SELECT * FROM exp_ajw_client_downloads_settings");

		$r = "";

		$r .= $this->_navigation();

		if ($msg != '')
		{
			$r .= $DSP->qdiv('successBox', $DSP->qdiv('success', $msg)) . BR;
		}

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=update_settings', 
				'name' => 'settings', 
				'id' => 'setings'
			)
		);

		if ( $query->num_rows > 0 ) {
			$r .= $DSP->input_hidden( 'id', $query->row["id"] ); 
		}
		
		$r .= $DSP->qdiv( 'tableHeading', 'Edit settings' ); 
		$r .= $DSP->table('tableBorder', '0', '0', '100%');

		$r .= $DSP->tr() .
			$DSP->td('tableHeadingAlt', '', '2') . 'Paths' . $DSP->td_c() .
			$DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qspan('alert', '* ') . 
			$DSP->qspan('defaultBold', 'Basepath', '30%') .
			$DSP->qdiv('default', 'The path on the server to store assets', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('basepath', 
							( $query->num_rows > 0 ? $query->row["basepath"] : "" )
					, '35', '255', 'input', '45%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 'Server path for manual upload of files', '30%') .
			$DSP->qdiv('default', 'Temporary folder to manually upload files by ftp', '30%')
		);
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('temp_path', 
							( $query->num_rows > 0 ? $query->row["temp_path"] : "" )
					, '35', '255', 'input', '45%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr() .
			$DSP->td('tableHeadingAlt', '', '2') . 'Email notification for new download area' . $DSP->td_c() .
			$DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 'Notification Email Subject', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('email_subject', 
							( $query->num_rows > 0 ? $query->row["email_subject"] : "" )
					, '35', '255', 'input', '45%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 'Notification Email From', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('email_from', 
							( $query->num_rows > 0 ? $query->row["email_from"] : "" )
					, '35', '255', 'input', '45%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 'Notification Email Message', '30%') .
			$DSP->qdiv('default', 'Leave blank to not send an email', '30%'), 
			'', 'top' 
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_textarea('email_body', ( isset($query->row["email_body"]) ? $query->row["email_body"] : "" ), 6, 'textarea', '75%')
				)
			),
			'70%', 'top'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr() .
			$DSP->td('tableHeadingAlt', '', '2') . 'Email notification for new asset uploaded' . $DSP->td_c() .
			$DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 'New Asset Email Subject', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('new_asset_email_subject', 
							( $query->num_rows > 0 ? $query->row["new_asset_email_subject"] : "" )
					, '35', '255', 'input', '45%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 'New Asset Email From', '30%') 
		);
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('new_asset_email_from', 
							( $query->num_rows > 0 ? $query->row["new_asset_email_from"] : "" )
					, '35', '255', 'input', '45%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 'New Asset Email Message', '30%') .
			$DSP->qdiv('default', 'Leave blank to not send an email', '30%'), 
			'', 'top'
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_textarea('new_asset_email_body', (isset($query->row["new_asset_email_body"]) ? $query->row["new_asset_email_body"] : ""), 6, 'textarea', '75%')
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();

		if ( isset( $query->row["user_fields"] ) ) {
			$user_fields = split(", ", $query->row["user_fields"]);
		} else {
			$user_fields = array();
		}

		$fields = "";
		$member_fields = array( 
			"username" => "Username", 
			"email" => "Email",
			"url" => "URL",
			"location" => "Location",
			"occupation" => "Occupation"
		);
		foreach( $member_fields as $key => $value ) {
			if ( in_array( "m.".$key, $user_fields ) ) {
				$fields .= $DSP->input_select_option("m.".$key, $value, 'y');
			} else {
				$fields .= $DSP->input_select_option("m.".$key, $value);
			}
		}

		$subquery = $DB->query("SELECT m_field_id, m_field_label FROM exp_member_fields");
		foreach( $subquery->result as $subrow ) {
			if ( in_array( "d.m_field_id_".$subrow["m_field_id"], $user_fields ) ) {
				$fields .= $DSP->input_select_option("d.m_field_id_".$subrow["m_field_id"], $subrow["m_field_label"], 'y');
			} else {
				$fields .= $DSP->input_select_option("d.m_field_id_".$subrow["m_field_id"], $subrow["m_field_label"]);
			}
		}
		
		$r .= $DSP->tr() .
			$DSP->td('tableHeadingAlt', '', '2') . 'Control Panel Display options' . $DSP->td_c() .
			$DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 'Custom member fields', '30%') .
			$DSP->qdiv('default', 'Choose fields you would like to appear on the Users page', '30%'), 
			'', 'top'
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_select_header('user_fields[]', 'y', 6) .
					$fields .
					$DSP->input_select_footer()
				)
			),
			'70%'
		);
		$r .= $DSP->tr_c();
		

		$r .= $DSP->table_c();

		$r .= $DSP->qdiv('itemWrapper', 
			$DSP->qspan('alert', '* ') .
			$DSP->qspan('default', 'indicates required fields') 
			);

		$r .= $DSP->qdiv('itemWrapper', $DSP->input_submit('Update'));  

		$r .= $DSP->form_c();

		$DSP->body .= $r;
	}	

	function update_settings()
	{
		global $LANG, $DB, $IN, $DSP, $FNS, $LOC;

		$id = $IN->GBL("id");

    if ( $IN->GBL("basepath") == '')
    {
    	$DSP->body .= $DSP->error_message("Asset must have a base path");        
      return;
    } 

		$user_fields = "";
		if( is_array( $IN->GBL("user_fields") ) ) {
			$user_fields = join(", ", $IN->GBL("user_fields"));
		}

		if ( $id != "" ) {
			
			// Do update
			
			$data = array(
				"basepath" => $IN->GBL("basepath"), 
				"email_subject" => $IN->GBL("email_subject"), 
				"email_from" => $IN->GBL("email_from"), 
				"email_body" => $IN->GBL("email_body"),
				"new_asset_email_subject" => $IN->GBL("new_asset_email_subject"), 
				"new_asset_email_from" => $IN->GBL("new_asset_email_from"), 
				"new_asset_email_body" => $IN->GBL("new_asset_email_body"),
				"user_fields" => $user_fields,
				"temp_path" => $IN->GBL("temp_path")
			);
			$DB->query( 
				$DB->update_string( 
					"exp_ajw_client_downloads_settings", 
					$data, 
					"id = " . $DB->escape_str( $id )
				)
			);

		} else {
			
			// Insert new asset record
			
			$data = array(
				"basepath" => $IN->GBL("basepath"), 
				"email_subject" => $IN->GBL("email_subject"), 
				"email_from" => $IN->GBL("email_from"), 
				"email_body" => $IN->GBL("email_body"),
				"new_asset_email_subject" => $IN->GBL("new_asset_email_subject"), 
				"new_asset_email_from" => $IN->GBL("new_asset_email_from"), 
				"new_asset_email_body" => $IN->GBL("new_asset_email_body"),
				"user_fields" => $user_fields,
				"temp_path" => $IN->GBL("temp_path")
			);
			$DB->query( 
				$DB->insert_string( 
					"exp_ajw_client_downloads_settings", 
					$data
				) 
			);

		}
		
		$this->settings("Settings updated");
		
	}

	function multi_edit() {
		global $IN, $DB, $DSP, $LANG;

		return $this->home();	
	}



	// ----------------------------------------
	//  Private Functions
	// ----------------------------------------

	function _navigation( $highlight = "" ) {
		global $DSP, $IN;
		
		$navigation = array(
			"users" => array(
				"class" => "altTabs", 
				"width" => "20%", 
				"text" => $DSP->anchor(
					BASE.AMP."C=modules".AMP."M=".$this->module_name.AMP."P=users", 
					"Users"
				)
			),
			"assets" => array(
				"class" => "altTabs", 
				"width"  => "20%", 
				"text" => $DSP->anchor(
					BASE.AMP."C=modules".AMP."M=".$this->module_name.AMP."P=assets", 
					"Assets"
				)
			),
			"folders" => array(
				"class" => "altTabs", 
				"width"  => "20%", 
				"text" => $DSP->anchor(
					BASE.AMP."C=modules".AMP."M=".$this->module_name.AMP."P=folders", 
					"Folders"
				)
			),
			"reports" => array(
				"class" => "altTabs", 
				"width"  => "20%", 
				"text" => $DSP->anchor(
					BASE.AMP."C=modules".AMP."M=".$this->module_name.AMP."P=reports", 
					"Reports"
				)
			),
			"settings" => array(
				"class" => "altTabs", 
				"width"  => "20%", 
				"text" => $DSP->anchor(
					BASE.AMP."C=modules".AMP."M=".$this->module_name.AMP."P=settings", 
					"Settings"
				)
			)
		);

		if ( $highlight != "" ) {
			$navigation[ $highlight ][ "class" ] = "altTabSelected";
		} elseif ( isset( $navigation[ $IN->GBL("P") ] )) {
			$navigation[ $IN->GBL("P") ][ "class" ] = "altTabSelected";			
		}

		return $DSP->table_open( array('width' => '100%') ) .
			$DSP->table_row( $navigation ) .		
			$DSP->table_close() . BR;
	}

	function _date( $timestamp )
	{
		
		if(date("Ymd", $timestamp) < date("Ymd", strtotime("+1 week")) && date("Ymd", $timestamp) > date("Ymd", strtotime("tomorrow")))
		{
			return "Next ".date("l",$timestamp)." ".date("h:i a",$timestamp);
		}
		else if(date("Ymd", $timestamp) == date("Ymd", strtotime("tomorrow")))
		{
			return "Tomorrow ".date("h:i a",$timestamp);
		}
		else if(date("Ymd", $timestamp) == date("Ymd"))
		{
			return "Today ".date("h:i a",$timestamp);
		}
		else if(date("Ymd", $timestamp) == date("Ymd", strtotime("yesterday")))
		{
			return "Yesterday ".date("h:i a",$timestamp);
		}
		else if(date("Ymd", $timestamp) > date("Ymd", strtotime("-1 week")) && date("Ymd", $timestamp) < date("Ymd", strtotime("tomorrow")))
		{
			return "Last ".date("l",$timestamp)." ".date("h:i a",$timestamp);
		}
		else
		{
			return date("M d, Y h:i a", $timestamp); 
		}
	}

	function _size( $size )
	{
		if($size / 1048576 > 1)
		{
			return round($size / 1048576, 2)." MB";
		}
		if($size / 1024 > 1)
		{
			return round($size / 1024, 2)." KB";
		}
		return round($size, 2)." B";
	}
	
	// ----------------------------------------
	//  Module installer
	// ----------------------------------------

	function ajw_client_downloads_module_install()
	{
		global $DB;

		// Install module

		$sql[] = "INSERT INTO exp_modules (
			module_id, 
			module_name,
			module_version,
			has_cp_backend
		) VALUES (
			'',
			'" . $this->module_name . "',
			'" . $this->version . "',
			'y'
			)";

		// Create databases
		
		$sql[] = "CREATE TABLE IF NOT EXISTS `exp_ajw_client_downloads_settings` (
			`id` int(10) NOT NULL auto_increment,
			`basepath` varchar(255) NOT NULL,
			`email_subject` varchar(255) NOT NULL,
			`email_from` varchar(255) NOT NULL,
			`email_body` text NOT NULL,
			`new_asset_email_from` varchar(255) NOT NULL,
			`new_asset_email_body` text NOT NULL,
			`new_asset_email_subject` varchar(255) NOT NULL,
			`user_fields` varchar(255) NOT NULL,
			`temp_path` varchar(255) NOT NULL,
			PRIMARY KEY ( `id` ))" ;

		$sql[] = "CREATE TABLE IF NOT EXISTS `exp_ajw_client_downloads_users` (
			`id` int(10) NOT NULL auto_increment,
			`member_id` int(10) unsigned NOT NULL,
			`folder_id` int(10) NOT NULL,
			`created` int(10) default NULL,
			PRIMARY KEY ( `id` ))" ;

		$sql[] = "CREATE TABLE IF NOT EXISTS `exp_ajw_client_downloads_folder` (
			`id` int(10) NOT NULL auto_increment,
			`title` varchar(255) NOT NULL,
			`description` text NOT NULL,
			`created` int(10) default NULL,
			PRIMARY KEY ( `id` ))" ;

		$sql[] = "CREATE TABLE IF NOT EXISTS `exp_ajw_client_downloads_asset` (
			`id` int(10) NOT NULL auto_increment,
			`title` varchar(255) NOT NULL,
	  	`keywords` varchar(255) NOT NULL,
	  	`description` text NOT NULL,
			`path` varchar(255) NOT NULL,
			`created` int(10) default NULL,
			PRIMARY KEY ( `id` ))" ;

		$sql[] = "CREATE TABLE IF NOT EXISTS `exp_ajw_client_downloads_folder_assets` (
			`id` int(10) NOT NULL auto_increment,
			`folder_id` int(10) NOT NULL,
			`asset_id` int(10) NOT NULL,
			`created` int(10) default NULL,
			PRIMARY KEY ( `id` ))" ;

		$sql[] = "CREATE TABLE IF NOT EXISTS `exp_ajw_client_downloads_log` (
			`id` int(10) NOT NULL auto_increment,
			`asset_id` int(10) NOT NULL,
			`member_id` int(10) unsigned NOT NULL,
			`created` int(10) default NULL,
			PRIMARY KEY ( `id` ))" ;	
		
		// Create actions
		
		$sql[] = "INSERT INTO exp_actions (action_id, class, method) VALUES ('', '" . $this->module_name . "', 'download_asset')";
		

		foreach ($sql as $query)
		{
			$DB->query($query);
		}

		return true;
	}
	// END    

	// ----------------------------------------
	//  Module de-installer
	// ----------------------------------------

	function ajw_client_downloads_module_deinstall()
	{
		global $DB;    

		$query = $DB->query("SELECT module_id FROM exp_modules WHERE module_name = '" . $this->module_name . "'"); 

		$sql[] = "DELETE FROM exp_module_member_groups 
			WHERE module_id = '".$query->row['module_id']."'";      

		$sql[] = "DELETE FROM exp_modules 
			WHERE module_name = '" . $this->module_name ."'";

		$sql[] = "DELETE FROM exp_actions 
			WHERE class = '" . $this->module_name . "'";

		$sql[] = "DELETE FROM exp_actions 
			WHERE class = '" . $this->module_name . "_CP'";

		foreach ($sql as $query)
		{
			$DB->query($query);
		}

		return true;
	}
	// END
}

?>