<?php

if ( ! defined('EXT'))
{
	exit('Invalid file request');
}


class Ajw_client_downloads {

	var $return_data	= '';

	var $member_id = 0;

	// -------------------------------------
	//  Constructor
	// -------------------------------------

	function Ajw_client_downloads()
	{        
	}

	function folder() {
		global $DB, $SESS, $TMPL, $FNS, $LOC, $IN;
		
		if ( !$this->_member_id() )
		{
			return $TMPL->no_results();
		}
		
		$tagdata = $TMPL->tagdata;
		
		$sql = "SELECT f.id as folder_id, f.title, f.description FROM exp_ajw_client_downloads_folder f INNER JOIN exp_ajw_client_downloads_users u ON u.folder_id = f.id WHERE u.member_id = " . $this->member_id;
		
		if( $TMPL->fetch_param('folder_id') )
		{
			$sql .= " AND f.id IN (" . $TMPL->fetch_param('folder_id') . ")";
		}
		
		if ( $TMPL->fetch_param('orderby') )
		{
			$sql .= " ORDER BY f." . $TMPL->fetch_param('orderby');
		} else {
			$sql .= " ORDER BY f.id";			
		}

		if ( $TMPL->fetch_param('sort') == "desc" )
		{
			$sql .= " DESC";
		}		
		
		if ( is_numeric( $TMPL->fetch_param('limit') ) )
		{
			$sql .= " LIMIT " . $TMPL->fetch_param('limit');
		}		

		$outer = $DB->query($sql);

		if ( $outer->num_rows == 0 ) {
			return $TMPL->no_results;
		}

		$download_url = $FNS->fetch_site_index() . "?ACT=" . $FNS->fetch_action_id('Ajw_client_downloads', 'download_asset');

		// Outer loop over all folders
		$out ="";
		
		$count = 0;
		foreach ( $outer->result as $row ) {
			$block = $tagdata;

			$block = str_replace( LD."folder_id".RD, $row["folder_id"], $block );
			$block = str_replace( LD."folder_title".RD, $row["title"], $block );
			$block = str_replace( LD."folder_description".RD, $row["description"], $block );

			// Inner loop over assets
			if ( preg_match( "/".LD."assets(.*?)".RD."(.*?)".LD.SLASH.'assets'.RD."/s", $block, $matches ) ) {
			
			$params = $FNS->assign_parameters( $matches['1'] );
			$assets = "";
			$sql = "SELECT a.id, a.title, a.path, a.description, a.keywords, fa.created as assigned, a.created as created, s.basepath FROM exp_ajw_client_downloads_asset a, exp_ajw_client_downloads_folder_assets fa, exp_ajw_client_downloads_settings s WHERE fa.asset_id = a.id AND fa.folder_id =" . $row["folder_id"];
			if ( $TMPL->fetch_param('query') != "" && $IN->GBL($TMPL->fetch_param('query')) != "" )
			{
				$sql .= ' AND CONCAT(a.title, a.description, a.keywords) LIKE "%' . $IN->GBL($TMPL->fetch_param('query')) . '%"';
			}		
			if ( isset( $params['orderby'] ) ) {
				$sql .= " ORDER BY " . $params['orderby'];
			}
			if ( isset( $params['sort'] ) ) {
				$sql .= " " . $params['sort'];
			}
			$inner = $DB->query($sql);
			
			$cond = array();
			$cond['no_assets'] = ( $inner->num_rows > 0) ? 'FALSE' : 'TRUE';
			$block = $FNS->prep_conditionals( $block, $cond );
			
			foreach ( $inner->result as $inner_row ) {
				
				$asset = $matches[2];

				$file = $inner_row["basepath"] . $inner_row["path"];

				$asset = str_replace( LD."id".RD, $inner_row["id"], $asset );
				$asset = str_replace( LD."title".RD, $inner_row["title"], $asset );
				$asset = str_replace( LD."description".RD, $inner_row["description"], $asset );
				$asset = str_replace( LD."keywords".RD, $inner_row["keywords"], $asset );
				$asset = str_replace( LD."url".RD, $download_url . "&id=" . $inner_row["id"], $asset );
				$asset = str_replace( LD."prettydate".RD, $this->_date( $inner_row["created"] ), $asset );
				$asset = str_replace( LD."date".RD, $LOC->set_human_time( $inner_row["created"] ), $asset );
				$asset = str_replace( LD."assigned".RD, $LOC->set_human_time( $inner_row["assigned"] ), $asset );
				$asset = str_replace( LD."size".RD, $this->_size( filesize( $file ) ), $asset );
				$extension = "none";
				preg_match("/\.([a-zA-Z]{2,4})$/", $file, $extensions);
				if( isset( $extensions[1] ) ) {
					$extension = $extensions[1];
				}
				$asset = str_replace( LD."extension".RD, $extension, $asset );
				
				$assets .= $asset;
			}	
			
			$block = preg_replace("/".LD."assets(.*?)".RD."(.*?)".LD.SLASH.'assets'.RD."/s", $assets, $block);		
			}
			
			$out .= $block;
		}
		
		return $out;
	}


	// -------------------------------------
	//  Constructor
	// -------------------------------------

	function download_asset() {
		global $DB, $IN, $SESS, $LOC, $OUT, $LANG;
	
		// Check the currently logged in user can download this file
		$sql = "SELECT CONCAT( s.basepath, a.path) as file, a.path as title FROM exp_ajw_client_downloads_folder_assets fa LEFT JOIN exp_ajw_client_downloads_asset a ON a.id = fa.asset_id LEFT JOIN exp_ajw_client_downloads_folder f ON f.id = fa.folder_id INNER JOIN exp_ajw_client_downloads_users u ON u.folder_id = f.id INNER JOIN exp_ajw_client_downloads_settings s WHERE u.member_id = " . $SESS->userdata["member_id"]. " AND fa.asset_id = " . $DB->escape_str($IN->GBL("id"));
		$query = $DB->query($sql);
		
		if ( $query->num_rows > 0 ) {

			// Log download
			$data = array(
				'asset_id' => $IN->GBL("id"),
				'member_id' => $SESS->userdata["member_id"],
				'created' => $LOC->now
			);
			$DB->query( $DB->insert_string('exp_ajw_client_downloads_log', $data) );

			// Download file
			$this->_send_file( $query->row["file"], $query->row["title"] );

			//exit;
						
		} else {
			
			// Permission denied
			return $OUT->show_user_error('general', array($LANG->line('not_authorized')));
			
		}
		
	}
	
	
	// -------------------------------------
	//  Private Functions
	// -------------------------------------	
	
	function _member_id() {
		global $TMPL, $SESS;
		
		// Check parameters
		if ( is_numeric( $TMPL->fetch_param('member_id') ) )
		{
			$this->member_id	= $TMPL->fetch_param('member_id');			
			return TRUE;
		}
		
		// Use current member
		if ( $SESS->userdata('member_id') != '0' )
		{
			$this->member_id	= $SESS->userdata('member_id');			
			return TRUE;
		}
		
		return FALSE;
	}
	
	function _date( $timestamp )
	{
		
		if(date("Ymd", $timestamp) < date("Ymd", strtotime("+1 week")) && date("Ymd", $timestamp) > date("Ymd", strtotime("tomorrow")))
		{
			return "Next ".date("l",$timestamp)." ".date("h:i a",$timestamp);
		}
		else if(date("Ymd", $timestamp) == date("Ymd", strtotime("tomorrow")))
		{
			return "Tomorrow ".date("h:i a",$timestamp);
		}
		else if(date("Ymd", $timestamp) == date("Ymd"))
		{
			return "Today ".date("h:i a",$timestamp);
		}
		else if(date("Ymd", $timestamp) == date("Ymd", strtotime("yesterday")))
		{
			return "Yesterday ".date("h:i a",$timestamp);
		}
		else if(date("Ymd", $timestamp) > date("Ymd", strtotime("-1 week")) && date("Ymd", $timestamp) < date("Ymd", strtotime("tomorrow")))
		{
			return "Last ".date("l",$timestamp)." ".date("h:i a",$timestamp);
		}
		else
		{
			return date("M d, Y h:i a", $timestamp); 
		}
	}
	
	function _size( $size )
	{
		if($size / 1048576 > 1)
		{
			return round($size / 1048576, 2)." MB";
		}
		if($size / 1024 > 1)
		{
			return round($size / 1024, 2)." KB";
		}
		return round($size, 2)." B";
	}

	function _send_file($path, $filename) {

		session_write_close();
		if (!is_file($path) || connection_status()!=0)
			return(FALSE);

		// set_time_limit(0);

		$name = basename($path);

		if ( ! function_exists ( 'mime_content_type' ) )
		{
			function mime_content_type ( $f )
			{
				include_once(PATH_LIB.'mimes.php');
				$x = explode('.', $f);
				$ext = strtolower(end($x));
				return ( isset( $mimes[ $ext ] ) ? $mimes[ $ext ] : 'application/octet-stream' );
			}
		}

		$mimetype = mime_content_type( $path );

		header("Content-Type: " . $mimetype);
		header('Content-Disposition: attachment; filename="'.$filename.'"');
		header("Content-Length: " . (string)(filesize($path)) );

		readfile($path);
		
		return((connection_status()==0) and !connection_aborted());
	}

	// END

}
// END CLASS

?>